Proxmox/install/trilium-install.sh

144 lines
3.9 KiB
Bash
Raw Normal View History

2022-09-11 20:52:16 +02:00
#!/usr/bin/env bash
2022-12-22 21:04:51 +01:00
if [ "$VERBOSE" == "yes" ]; then set -x; fi
2022-10-30 02:04:45 +01:00
YW=$(echo "\033[33m")
RD=$(echo "\033[01;31m")
BL=$(echo "\033[36m")
GN=$(echo "\033[1;92m")
CL=$(echo "\033[m")
2022-09-11 20:52:16 +02:00
RETRY_NUM=10
RETRY_EVERY=3
NUM=$RETRY_NUM
CM="${GN}${CL}"
CROSS="${RD}${CL}"
BFR="\\r\\033[K"
HOLD="-"
set -o errexit
set -o errtrace
set -o nounset
set -o pipefail
shopt -s expand_aliases
alias die='EXIT=$? LINE=$LINENO error_exit'
trap die ERR
function error_exit() {
trap - ERR
local reason="Unknown failure occurred."
local msg="${1:-$reason}"
local flag="${RD}‼ ERROR ${CL}$EXIT@$LINE"
echo -e "$flag $msg" 1>&2
exit $EXIT
}
function msg_info() {
2022-10-30 02:04:45 +01:00
local msg="$1"
echo -ne " ${HOLD} ${YW}${msg}..."
2022-09-11 20:52:16 +02:00
}
function msg_ok() {
2022-10-30 02:04:45 +01:00
local msg="$1"
echo -e "${BFR} ${CM} ${GN}${msg}${CL}"
2022-09-11 20:52:16 +02:00
}
function msg_error() {
2022-10-30 02:04:45 +01:00
local msg="$1"
echo -e "${BFR} ${CROSS} ${RD}${msg}${CL}"
2022-09-11 20:52:16 +02:00
}
msg_info "Setting up Container OS "
sed -i "/$LANG/ s/\(^# \)//" /etc/locale.gen
locale-gen >/dev/null
while [ "$(hostname -I)" = "" ]; do
2022-10-30 02:04:45 +01:00
echo 1>&2 -en "${CROSS}${RD} No Network! "
2022-09-11 20:52:16 +02:00
sleep $RETRY_EVERY
((NUM--))
2022-10-30 02:04:45 +01:00
if [ $NUM -eq 0 ]; then
echo 1>&2 -e "${CROSS}${RD} No Network After $RETRY_NUM Tries${CL}"
2022-09-11 20:52:16 +02:00
exit 1
fi
done
msg_ok "Set up Container OS"
msg_ok "Network Connected: ${BL}$(hostname -I)"
2022-10-22 11:52:33 +02:00
set +e
alias die=''
2022-10-30 02:04:45 +01:00
if nc -zw1 8.8.8.8 443; then msg_ok "Internet Connected"; else
msg_error "Internet NOT Connected"
read -r -p "Would you like to continue anyway? <y/N> " prompt
if [[ $prompt == "y" || $prompt == "Y" || $prompt == "yes" || $prompt == "Yes" ]]; then
echo -e " ⚠️ ${RD}Expect Issues Without Internet${CL}"
else
echo -e " 🖧 Check Network Settings"
exit 1
fi
2022-10-30 02:04:45 +01:00
fi
2022-09-11 20:52:16 +02:00
RESOLVEDIP=$(nslookup "github.com" | awk -F':' '/^Address: / { matched = 1 } matched { print $2}' | xargs)
2022-10-30 02:04:45 +01:00
if [[ -z "$RESOLVEDIP" ]]; then msg_error "DNS Lookup Failure"; else msg_ok "DNS Resolved github.com to $RESOLVEDIP"; fi
2022-10-22 11:52:33 +02:00
alias die='EXIT=$? LINE=$LINENO error_exit'
set -e
2022-09-11 20:52:16 +02:00
msg_info "Updating Container OS"
apt-get update &>/dev/null
apt-get -y upgrade &>/dev/null
msg_ok "Updated Container OS"
msg_info "Installing Dependencies"
apt-get install -y curl &>/dev/null
apt-get install -y sudo &>/dev/null
msg_ok "Installed Dependencies"
2022-10-30 02:04:45 +01:00
RELEASE=$(curl -s https://api.github.com/repos/zadam/trilium/releases/latest |
grep "tag_name" |
awk '{print substr($2, 3, length($2)-4) }')
2022-09-12 02:52:26 +02:00
2022-09-11 20:52:16 +02:00
msg_info "Installing Trilium"
2022-09-12 02:52:26 +02:00
wget -q https://github.com/zadam/trilium/releases/download/v$RELEASE/trilium-linux-x64-server-$RELEASE.tar.xz
tar -xvf trilium-linux-x64-server-$RELEASE.tar.xz &>/dev/null
2022-09-11 20:52:16 +02:00
mv trilium-linux-x64-server /opt/trilium
msg_ok "Installed Trilium"
msg_info "Creating Service"
service_path="/etc/systemd/system/trilium.service"
echo "[Unit]
Description=Trilium Daemon
After=syslog.target network.target
[Service]
User=root
Type=simple
ExecStart=/opt/trilium/trilium.sh
WorkingDirectory=/opt/trilium/
TimeoutStopSec=20
Restart=always
[Install]
2022-10-30 02:04:45 +01:00
WantedBy=multi-user.target" >$service_path
2022-09-11 20:52:16 +02:00
systemctl enable --now -q trilium
msg_ok "Created Service"
2022-10-30 02:04:45 +01:00
PASS=$(grep -w "root" /etc/shadow | cut -b6)
if [[ $PASS != $ ]]; then
msg_info "Customizing Container"
chmod -x /etc/update-motd.d/*
touch ~/.hushlogin
GETTY_OVERRIDE="/etc/systemd/system/container-getty@1.service.d/override.conf"
mkdir -p $(dirname $GETTY_OVERRIDE)
cat <<EOF >$GETTY_OVERRIDE
2022-09-11 20:52:16 +02:00
[Service]
ExecStart=
ExecStart=-/sbin/agetty --autologin root --noclear --keep-baud tty%I 115200,38400,9600 \$TERM
EOF
2022-10-30 02:04:45 +01:00
systemctl daemon-reload
systemctl restart $(basename $(dirname $GETTY_OVERRIDE) | sed 's/\.d//')
msg_ok "Customized Container"
fi
if [[ "${SSH_ROOT}" == "yes" ]]; then
2022-12-19 17:08:29 +01:00
sed -i "s/#PermitRootLogin prohibit-password/PermitRootLogin yes/g" /etc/ssh/sshd_config
systemctl restart sshd
fi
2022-10-30 02:04:45 +01:00
2022-09-11 20:52:16 +02:00
msg_info "Cleaning up"
apt-get autoremove >/dev/null
apt-get autoclean >/dev/null
2022-09-23 18:12:58 +02:00
rm -rf /root/trilium-linux-x64-server-$RELEASE.tar.xz
2022-09-11 20:52:16 +02:00
msg_ok "Cleaned"